Valhalla is an open-source toolkit for multimodal transportation, powered by open data.

The **route** service guides you between points by car, bike, foot, and multimodal combinations involving walking and riding public transit. Your apps can use the results from the route service to plan multimodal journeys with narratives to guide users by text and by voice. Valhalla draws data from OpenStreetMap and from [Transitland](https://transit.land/documentation/), the open transit data aggregation project. See the [api documentation](/turn-by-turn/api-reference.md).

Trying to run more than one errand in the day or start your own delivery service? The **optimized route** service computes the times and distances between many origins and destinations and provides you with an optimized path between the locations. See the [api documentation](/optimized/api-reference.md).

If you want only a table of the times and distances, start with the **matrix** service. See the [api documentation](/matrix/api-reference.md).

Use the **isocrhone** service to get a computation of areas that are reachable within specified time periods from a location or set of locations. See the [api documentation](/isochrone/api-reference.md).

The **map-matching** service matches coordinates to known roads so you can turn a path into a route with narrative instructions and get the attribute values from that matched line. See the [api documentation](/map-matching/api-reference.md).

Use the **elevation** service to find the elevation along a path or at specified locations. See the [api documentation](/elevation/api-reference.md).

Use the **transit available** service to check the availability of transit for at least 1 location. See the [api documentation](/transit-available/api-reference.md).

